<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>Howto build SLINKY from scratch</title>
    <base href="http://www.fzk.at/SLINKY/builder_guide/slinky_sysarch.html"/>

    <style type="text/css">
      .codeblock { margin:.3cm;
              margin-right:30%;
              color:blue; background-color:white;
              text-align:left; }
      .inlinecode { margin:.3cm;
              color:blue; background-color:white; }
      .path { margin:.3cm;
              color:blue; background-color:white; }
      .option { margin:.3cm;
              color:red; background-color:white; }
    </style>
</head>

  <body>
    <h1>Howto build SLINKY from scratch</h1>
    <p><img src="./slinky_sysarch.png" alt="Diagram of SLINKY's system architecture" usemap="#Slinky"><br>
      <a href="./slinky_sysarch.pdf">Slinky sysarch (pdf)</a>

include(slinky_sysarch.map)dnl

</p>

    <h2>Abstract</h2>
    <p>
      SLINKY ist der Versuch, mit minimalen Mitteln eine ausgewachsene
      LINUX Distribution, nmlich FEDORA, auch auf solchen PCs
      installieren zu knnen, auf denen der eigentliche Installer
      ANACONDA wegen zu geringer Systemrecourcen (Memory, CPU-Type)
      nicht luft, obwohl das Gert ansonsten durchaus in der Lage
      wre, LINUX zu betreiben.  SLINKY ist also ein <span class="inlinecode">Installer
      fr FEDORA</span> und hierin liegt auch seine Besonderheit.
      Gelingt es, FEDORA nicht nur zu installieren, sondern
      anschliessend auch zu booten, stehen prinzipiell alle
      Mglichkeiten von FEDORA zur Verfgung, insbesondere die
      Installation weiterer rpm-Pakete, nun aber bereits unter der
      Kontrolle FEDORAs selbst.</p>
    <p>
      Abgesehen von seiner Funktion als Installer, kann SLINKY aber
      auch als einfache RESCUE-Floppy angesehen werden.  Der
      wesentliche Aspekt dieser Facette von SLINKY ist ein aktueller
      LINUX-2.6-Kernel, mit all seinen Mglichkeiten, das System durch
      die Sicht des <span class="path">/proc</span>-Filesystems zu erforschen.  Fr den zur
      Installation verwendeten Kernel stehen alle Module in
      kompilierter Form als iso9660-Image zur Verfgung.</p>
    <p>
      Auf Grund der einfachen, geradlinigen Struktur, eignet sich
      SLINKY aber auch sehr gut als Demonstrations- und Lernobjekt, um
      unmittelbar zu sehen, wie die Installtion eines aktuellen
      UNIX-Systems ablaufen kann, welche Komponenten daran beteiligt
      sind und wie diese zusammenwirken.</p>
    <p>
      Der Slinky Installer wurde ursprnglich im Zuge des <a
      href="http://www.rule-project.org">RULE-Projekes</a>
      erstellt.</p>
    <p>
      The copyright notice from about slinky-v0.3.96 was
<pre>
# Copyright (C) 2002 Michael Fratoni
# &lt;Devon@tuxfan.homeip.net&gt;
# Copyright (C) The "RULE" project
# http://www.freesoftware.fsf.org/rule
	</pre>




    <ol>
      <li><a name="download_boot_floppy_func"><h2>Download Slinky Boot Floppy</h2></a>
	<p>
	  The easiest way to get in touch with SLINKY is by using the
	  SLINKY Boot Floppy.  It is of no harm to try to boot with it
	  and see what happens.  Try it.  You will be warned before
	  any sereous action to take place like partitioning or
	  formatting a disk.  If you are actually going to install
	  FEDORA with SLINKY you also need at least CD1 from FEDORA
	  Core4 from the <a
	  href="http://download.fedora.redhat.com/pub/fedora/linux/core/4/i386/iso">FEDORA
	  Download Server</a> or its mirrors.  The name of the file
	  is: <span class="path">FC4-i386-disc1.iso</span>.</p>

	<ol>
	  <li><a name="download_boot_floppy"><h3>download_boot_floppy</h3></a>
	    <p>
	      You can download the floppy image from <a
	      href="http://www.fzk.at/SLINKY/slinky-0.5.03-disk1.img">http://www.fzk.at/SLINKY/slinky-0.5.03-disk1.img</a>.</p></li>
	  <li><a name="boot_floppy"><h3>boot_floppy</h3></a>
	    <p>
	      To create the real Slinky Boot Floppy use</p>
	      <div class="codeblock"># dd if=slinky-0.5.03-disk1.img of=/dev/fd0</div>
	      <p>
	      to copy the image to a 1.44MB 3.5in. floppy. Under a none
	      UNIX-like operating system you need a tool like rawrite
	      to put the image to the floppy. The FEDORA-CDs provide
	      this utility in the <span class="inlinecode">/dosutil</span>
	      directory.</p></li>
	</ol>
      </li>





      <li><a name="download_module_img_func"><h2>Download Slinky Module Image</h2></a>
	<p>
	  If you have special hardware - and nearly everything exept a
	  simple IDE-based x86-system with floppy, harddisk and CD-ROM
	  might be special - you can use these modules to get SLINKY
	  working with your hardware.  Using modules is not that hard
	  but as there are too many modules to fit on a single floppy
	  you have to select the ones you need.  If at least the
	  CD-ROM is known by the SLINKY-install-kernel you can spend a
	  blank CD and have them at hand all at once.</p>

	<ol>
	  <li><a name="download_module_img"><h3>download_module_img</h3></a>
	    <p>
	      You can download the module image from <a
	      href="http://www.fzk.at/SLINKY/slinky-0.5.03-modules.img.bz2">http://www.fzk.at/SLINKY/slinky-0.5.03-modules.img.bz2</a>.</p></li>
	  <li><a name="module_img"><h3>module_img</h3></a>
	    <p>
	      Now that you downloaded the module image, you can
	      uncompress it with the utility bzip2, loopback mount
	      it and inspect its contents.  This can be done by:</p>
	      <div class="codeblock">bzip2 -dc slinky-0.5.03-modules.img.bz2<br>
		mount -t iso9660 -o loop slinky-0.5.03-modules.img /mnt/loop</div></li>
	</ol>
      </li>





      <li><a name="create_module_floppy_func"><h2>Create Module Floppy</h2></a>
	<p>
	  </p>

	<ol>

              <li><a name="kernel_modules"><h3>kernel_modules</h3></a>
	      <p>
		If you already have created the boot-kernel for Slinky
		creating the kernel-modules is easy:
<pre class="codeblock">
$ cd /usr/src/linux
$ su
# make modules
# make modules_install
# exit
		  </pre>
	  If everything worked fine this should have created <span
	  class="path">/lib/modules/2.6.9</span>
	  the kernel modules.
</p></li>

          <li><a name="customize_mod_modules"><h3>customize_mod_modules</h3></a>
	    <p>
	      I cannot explain in short and in detail how to create a floppy with
	      appropriate modules from all the available modules.</p>
	    <p>
	      In very short:</p>
	    <ul>
	      <li>loopback mount the iso9660 module image</li>
	      <li>format a floppy with an ext2 fileystem</li>
	      <li>copy any needed modules from the module image to the floppy but retain paths</li>
	    </ul>
	    <p>
	      If you cannot manage to get it to work please subscribe the <a
	      href="http://lists.hellug.gr/mailman/listinfo/rule-list">RULE-Mailing
	      List</a> and ask there.</p></li>
          <li><a name="modules_floppy"><h3>modules_floppy</h3></a>
	    <p>
	      If you customized your floppy with modules you can now
	      mount it under SLINKY at the mountpoint /lib/modules.
	      Then the utility modprobe can load them, but you have to
	      know theire names:</p>
	    <ul>
	      <li>rather at the beginning of the installation with
	      SLINKY select option: <span class="option">Drop to a  shell</span> to get a shell in the
	      old root context (means /-root directory of SLINKY
	      itself)</li>

	      <li>mount the floppy at directory <span class="path">/lib/modules</span>:
	      <div class="codeblock">mount -t ext2 /dev/fd0 /lib/modules</div></li>

	      <li>alternative: mount the the CD with all the modules:
	      <div class="codeblock">mount -t iso9660 /dev/cdrom
	      /lib/modules</div></li>

	      <li>then load the module with: <div class="codeblock">modprobe
	      _modulename_you_want_to_load_</div></li>

	    </ul></li>
	</ol>
      </li>





      <li><a name="create_boot_floppy_from_tarball_func"><h2>Create Slinky Boot Floppy from Tarball</h2></a>
	  <p>
	    If you want to modify the Slinky Boot Floppy you can
	    download the SLINKY devel-tarball, add your changes and
	    create the boot floppy or a bootable CD from it.  If you
	    even want to change the basic tools like busybox or use
	    another boot kernel, you can compile these components
	    yourself and replace the parts from the devel-tar.  As
	    SLINKY is protected by the GPL it is necessary to provide
	    any used source-code and instructions how to build it.  But
	    the sources of the LINUX-kernel and other tools are far
	    too big to provide them from a RULE-server.  We can only
	    tell which version of sourcecode we used and point you to
	    other download servers.  But we provide any config-Files
	    to compile these parts of SLINKY.</p>

        <ol>
          <li><a name="linux_source"><h3>linux_source</h3></a>
          <p>Location: <a
          href="http://www.fzk.at/SLINKY/kernel-2.6.9-config">.config
          for LINUX-kernel 2.6.9</a><br> The LINUX-sources are ready
          for download from <b>The Linux Kernel Archives</b>.  You
          would typically use a download server listed in <a
          href="http://www.kernel.org/mirrors">The Linux Kernel
          Archive Mirror System</a>.  In order to compile the kernel
          do the following:
<pre class="codeblock">
$ cd /usr/src
$ ... download the kernel sources ...
$ bzip2 -dc linux-2.6.9.tar.bz2 | tar -xvf -
$ ln -sf linux-2.6.9 linux
$ cd linux
$ ... download the Slinky .config-file to this directory ...
$ make oldconfig
$ make bzImage
</pre>
	  If everything worked fine this should have created <span
	  class="path">/usr/src/linux/arch/i386/boot/bzImage</span>
	  the LINUX-kernel.  To use it with Slinky copy this kernel to
	  your local copy of the devel-tree:
<pre class="codeblock">
$ su
# cp /usr/src/linux/arch/i386/boot/bzImage _devel-tree_/base_files/vmlinuz_rule
# _devel-tree_/makedisk.sh   ... this creates the Slinky boot floppy ...
# exit
	      </pre>

</p>  
</li>

	  <li><a name="busybox_source"><h3>busybox_source</h3></a>
	      <p>
		
</p></li>
          <li><a name="dialog_source"><h3>dialog_source</h3></a>
	      <p>
		
</p></li>
          <li><a name="uClibc_source"><h3>uClibc_source</h3></a>
	      <p>
		
</p></li>

          <li><a name="uClibc"><h3>uClibc</h3></a>
	      <p>
		
</p></li>

          <li><a name="devel_tar"><h3>devel_tarball</h3></a>
	      <p>
		Location: <a href="http://www.fzk.at/SLINKY/slinky-devel-0.5.03.tar.bz2">Develop tarball v0.5.03</a><br>
		If you want to create the Slinky boot floppy yourself you need the archive containing the develop files.
<pre class="codeblock">
$ cd ~
$ mkdir SLINKY_devel
$ cd SLINKY_devel
$ ... download the archive ...
$ su
# bzip2 -dc slinky-devel-0.5.03.bz2 | tar -xvf -
# exit
	      </pre>
</p></li>

          <li><a name="create_boot_floppy_func"><h2>Create Slinky Boot Floppy</h2></a>
            <ol>
              <li><a name="boot_kernel"><h3>boot_kernel</h3></a>
	      <p>
		Location: <span class="path">devel-tree/base_files/vmlinuz-rule</span><br>
		The boot-kernel is primaly configured to be small
		enough to fit on the boot-floppy, but also to be able
		to use IDE discs and CDs, some network cards and NFS.
		You find the .config at <span class="url">to_be_filled</span>.  The running kernel
		shows its configuration in the file <span class="path">/proc/config.gz</span>.  Use
		<div class="codeblock">gzip -dc /proc/config.gz</div>
		to list the contents.  </p></li>
              <li><a name="boot_msg_files"><h3>boot_msg_files</h3></a>
	      <p>
		Location: <span class="path">devel-tree/base_files</span><br>
		Before booting the kernel some screens of text show
		informations about SLINKY and what's going on.
		</p></li>
              <li><a name="busybox"><h3>busybox</h3></a>
	      <p>
		Location: <span class="path">devel-tree/filesystem/bin/busybox</span><br>
		
</p></li>
              <li><a name="cardmgr"><h3>cardmgr</h3></a>
	      <p>
	        This is an old binary.  By now I havn't got neither the source
	        nor the config file for this binary.</p></li>

              <li><a name="dialog"><h3>dialog</h3></a>
	      <p>
		
</p></li>

              <li><a name="mke2fs"><h3>mke2fs</h3></a>
	      <p>
	        This is an old binary.  By now I havn't got neither the source
	        nor the config file for this binary.</p></li>

              <li><a name="rootfs"><h3>rootfs</h3></a>
	      <p>
		Location: <span
		class="path">devel-tree/filesystem</span><br> This is
		the root filesystem as it is available while
		installing with SLINKY.  Thats the oldrood context.
		It is totally placed in a ram-disk.  </p></li>
              <li><a name="syslinux_config"><h3>syslinux_config</h3></a>
	      <p>
		Location: <span class="path">devel-tree/base_files/syslinux.cfg</span>
</p></li>
              <li><a name="syslinux"><h3>syslinux</h3></a>
	      <p>
		
</p></li>
            </ol>
        </ol>
      </li>





      <li><a name="provide_install_media_func"><h2>Provide FCx Install Media</h2></a>
	  <p>
	    In order to install FEDORA Core 4 on your PC you need the
	    rpm-packages contained on FC4 install media.</p>

        <ol>
          <li><a name="FCx_install_media"><h3>FCx_install_media</h3></a>
	      <p>
		You can download the CD iso-images from the <a
		href="http://download.fedora.redhat.com/pub/fedora/linux/core/4/i386/iso">FEDORA
		Download Server</a> or its mirrors.  The files are
		named: <span class="path">FC4-i386-disc[1234].iso</span>.  You can
		inspect the contents of these CD after downloding by
		loopback-mounting the iso-images:<br>

		<div>mount -t iso9660 -o loop _cd_device_ _mountpoint_</div>

		All the rpms are then located under the following PATH: _mountpoint_/Fedora/RPMS
</p></li>
          <li><a name="make_accessible"><h3>make_accessible</h3></a>
	      <p>
		SLINKY provides several ways to access the rpm-packages from the CD iso-images.  Choose your appropriate
install-methode.</p>
<pre class="codeblock">
     I You get | Source on harddisk | Source on CD I
     I source  |    in format       |              I
     I from:   | Fedora |   rpms**) |   Fedora     I
     I         |  iso*) |           |     iso      I
     I---------------------------------------------I
     I local   |    iso |      rpms |    cdrom     I
     I---------|--------+-----------I--------------I
     I nfs     | nfsiso |   nfsrpms I
     I---------|--------+-----------I
     I ftp     |   n/a  |   ftprpms I
     I------------------------------I
     *) ISOs are found, if placed in the top-level-directory of
        a local harddisk-partion or nfs-export-directory.
     **)RPMs are found, if placed in the $distri/RPMS directory.
	      </pre>
	      <p>
		Install methods when the rpms are locally available on the installation PC.</p>
	      <ul>
		<li><span class="option">cdrom</span> This is by far the best
		tested/working method.  With this method you burn the
		FC4 iso-images to CD.  This can be used, if SLINKY can
		detect the CD-drive of your installation PC.</li>

		<li><span class="option">iso</span> This method is similar to cdrom. In
		contrast to cdrom-method you dont burn CDs but use the
		iso-images directly.  This can be used if the
		installation PC has enough disk-space where you can
		provide the images.  You could copy the images at the
		download-PC to a harddisk and install this disk in the
		installation-PC.  Another usage of this method is when
		you repeatedly try different installations and dont
		want to change CDs.  Then copy the CDs to a
		disk-partition.  Installing from disk is also usually
		faster than from CD.</li>

		<li><span class="option">rpms</span> This method is similar to iso, but
		you have extracted the rpms in advance from the
		iso-images.  This method could be used, if you know
		exactly which rpms are needed and don't have space for
		4 CDs on your harddisk.</li>
	      </ul>

	      <p>
		Install methods when the rpms are available in the LAN via NFS.</p>
	      <ul>
		<li><span class="option">nfsiso</span> Like method iso but access is via NFS.</li>

		<li><span class="option">nfsrpms</span> Like method rpms but access is via NFS.</li>
	      </ul>

	      <p>
		Install methods when the rpms are available in the LAN via FTP.</p>
	      <ul>
		<li><span class="option">ftpiso</span> This theoretical method is not available, because the whole iso-image had to be copied over the LAN before installing the first package.  This has many disadvantages.</li>

		<li><span class="option">ftprpms</span>  Like method rpms but access is via FTP.</li>
	      </ul>

</p></li>
          <li><a name="mount_installsource"><h3>mount_installsource</h3></a>
	      <p>
		This function mounts the image if you install from an image.
</p></li>
        </ol>
      </li>




      <li><a name="install_fcx_func"><h2>Install FCx with Slinky</h2></a>
	  <p>
	    The process of installing FEDORA is devided into many
	    steps.  Usually they are performed in a predefined order
	    one by one.  But whenever the Slinky-menu prompts you
	    for the next already preselected task, you can change the
	    order of preocessing by selecting another one.  This can
	    be usefull if you performed some task giving certain
	    information but changed your mind afterwards.  Then you
	    don't have to start over again from booting the Slinky
	    boot floppy, which is very time consuming, but simply can
	    select this task and repeat it.  Some tasks like selecting
	    the keymap can be repeated at any time without the need to
	    also repeat any later task but others like partitioning
	    the harddisk cannot.</p>
	  <p>
	    The two tasks <span class="option">sh_newroot</span> and
	    <span class="option">sh_oldroot</span> can be selected at
	    any time to get a shell in the new (that's the new
	    installed /-root directory) or the old (that's Slinky's
	    /-root directory) filecontext.  The old filecontext is
	    marked whith the file <span
	    class="path">/_slinky_install_partition_</span> the new
	    filecontext is marked with the file <span
	    class="path">/_newroot_partition_</span> to make clear
	    which is what.</p>
	  <p>
	    The installer has activated 2 virtual ttys which can be
	    switched by typing the usual <span
	    class="inlinecode">&lt;alt&gt;-&lt;F2&gt;</span> to get to
	    the second tty and <span
	    class="inlinecode">&lt;alt&gt;-&lt;F1&gt;</span> to get
	    back to the first tty (that's where the installer is
	    running).</p>
	  <p>
	    The names of the following topics correspond to the
	    shell-scripts contained in <span
	    class="path">_devel-tree_/filesystem/scripts/</span>
	    (append .sh).</p>

	<ol>
          <li><a name="activate_swap"><h3>activate_swap</h3></a>
	      <p>
		This function activates the swap-partition for the
		installation.  Usually you have created a
		swap-partition on a harddisk and can use it now.  If
		your PC has enough memory you can skip this action.
		</p></li>

          <li><a name="base_install"><h3>base_install</h3></a></li>
          <li><a name="boot"><h3>boot</h3></a></li>
          <li><a name="boot_floppy"><h3>boot_floppy</h3></a></li>
          <li><a name="bootstrap_rpm"><h3>bootstrap_rpm</h3></a>
	      <p>
		Former versions of Slinky provided a second floppy
		mainly containing a rather big rpm-binary to perform
		the actual installation of the rpm-archives.  But
		busybox already contains a minimal rpm-binary which can be
		used to install the full featured rpm contained in the
		FEDORA distribution.  Ignore the error-messages during
		this bootstrap.</p></li>

          <li><a name="config_new"><h3>config_new</h3></a></li>
          <li><a name="do_partitioning"><h3>do_partitioning</h3></a>
	      <p>
		We use the busybox fdisk function to partition the
		harddisk(s).  There is nothing horrible about
		partitiong a harddisk, it's really a simple task.  But
		make shure to not re-partition just a disk containing
		data that you still need.  Usually you will not be
		able to access old data after re-parttioning.
		</p></li>

          <li><a name="format_mount"><h3>format_mount</h3></a></li>
          <li><a name="grub_install"><h3>grub_install</h3></a></li>
          <li><a name="in_newroot"><h3>in_newroot</h3></a>
	      <p>
	      </p></li>

          <li><a name="initial_reboot"><h3>initial_reboot</h3></a></li>
          <li><a name="mk_boot_floppy"><h3>mk_boot_floppy</h3></a></li>
          <li><a name="modules_floppy"><h3>modules_floppy</h3></a></li>
          <li><a name="mount_installsource"><h3>mount_installsource</h3></a></li>
          <li><a name="prepare_newroot"><h3>prepare_newroot</h3></a></li>
          <li><a name="run_installer"><h3>run_installer</h3></a></li>
          <li><a name="select_distri"><h3>select_distri</h3></a></li>

          <li><a name="select_fstype"><h3>select_fstype</h3></a>
	      <p>
		Slinky boot floppy supports 2 filesystems:</p>
	      <ul>
		<li><span class="option">ext2</span> the traditional LINUX filesystem</li>
		<li><span class="option">ext3</span> it's successor, with journaling functionality, the default option</li>
	      </ul></li>

          <li><a name="select_instdev"><h3>select_instdev</h3></a></li>

          <li><a name="select_keymap"><h3>select_keymap</h3></a>
	      <p>
		Slinky boot floppy supports 4 keymaps:</p>
	      <ul>
		<li><span class="option">us</span> for QWERTY-keyboards the default option</li>
		<li><span class="option">german</span> for QWERTZ with german umlauts</li>
		<li><span class="option">french</span> for AZERTY</li>
		<li><span class="option">italien</span> for QWERTZ with italien characters</li>
	      </ul>
	      <p>
		Here you find a description to add
		the mapping you are used to: <a
		  href="http://www.fzk.at/SLINKY/localized_keymap_en.html">english</a> <a
		  href="http://www.fzk.at/SLINKY/localized_keymap_de.html">deutsch</a>.
	      </p></li>

          <li><a name="select_method"><h3>select_method</h3></a></li>
          <li><a name="setup"><h3>setup</h3></a></li>
          <li><a name="sh_newroot"><h3>sh_newroot</h3></a></li>
          <li><a name="sh_oldroot"><h3>sh_oldroot</h3></a></li>
          <li><a name="umount_installsource"><h3>umount_installsource</h3></a></li>
	</ol>
      </li>




      <li><a name="use_new_system_func"><h2>The new system</h2></a>
	<ol>
          <li><a name="base_install"><h3>base_install</h3></a></li>
          <li><a name="bootable_Fedora"><h3>bootable_Fedora</h3></a></li>
          <li><a name="initial_boot"><h3>initial_boot</h3></a></li>
          <li><a name="configure_fedora"><h3>configure_fedora</h3></a></li>
          <li><a name="install_more_software"><h3>install_more_software</h3></a></li>
	</ol>
      </li>


    </ol>






    <hr>
    <address><a href="mailto:fzk@fzk.at">Franz Zahaurek</a></address>
<!-- Created: Sun Jan  1 11:05:58 CET 2006 -->
<!-- hhmts start -->
Last modified: Thu Jan 12 22:52:18 CET 2006
<!-- hhmts end -->
  </body>
</html>
