#! /bin/bash
#
#  mk_package_lists.sh      create the new package-lists based on older ones
#
#  Name of package lists: xxx_packages.disc#
#
#  contents: is list of basename of RPMS to be installed
#            comments start with --


old=~/RULE/slinky_devel/filesystem/scripts/3
new=~/RULE/slinky_devel/filesystem/scripts/4
RPMS='/mnt/FC4-disc?/Fedora/RPMS'

for list in $old/*_packages.disc?
do
    [ -f $new/`basename $list` ] && mv $new/`basename $list` $new/`basename $list`.old
    (
    cat $list | while read rpm
    do
	# echo '-- FC3:' $rpm          # old value as comment
	ls $RPMS/`echo $rpm | awk -F \- '{for (i=1;i<NF-1;i++) printf("%s-", $i); printf ("[0-9]\n");}'`*.rpm 2>&1 | sed -e 's/mnt/FC4-disc./Fedora/RPMS/' | grep -e 'i386.rpm$' -e 'noarch.rpm$' -e 'kernel-.*i586.rpm'
    done
    ) > $new/`basename $list`
done
