#! /bin/sh
#
#  bootstrap_rpm.sh   install full featured rpm with busybox-rpm
#

/root/scripts/mount_installsource.sh

# Bootstrap rpm of Fedora with busybox rpm
RPM_PATH="/mnt/cdrom/${distri}/RPMS/"
RPM_COMMAND="/bin/busybox rpm -i ${RPM_PATH}"

# Install rpm of Fedora
# This list was created by recursively following the dependencies of rpm
# in FC2: rpm -qR -p rpm-4.3.1-0.3.i386.rpm  and for all of its dependencies
# in FC3: rpm -qR -p rpm-4.3.2-2.i386.rpm  and for all of its dependencies

# echo bootstrap rpm: method=$method version=$version
# read x

dialog --no-cancel --no-collapse --msgbox "
    While installing rpm from FC4 you will see some errors like:

    *) ... File exists
    *) unknown group/user name ...
    *) need to fix this

    You can ignore them.
" 15 70

case $method in
cdrom|iso|rpms|nfsiso|nfsrpms)
    case $version in
    3)
	# echo
	# echo Bootstrap full featured rpm with busybox-rpm from $method
	# echo hit ENTER; read x
        ${RPM_COMMAND}tzdata-2004b-2.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}glibc-common-2.3.3-74.i386.rpm 2>/dev/null
        ${RPM_COMMAND}libgcc-3.4.2-6.fc3.i386.rpm 2>/dev/null
        ${RPM_COMMAND}setup-2.5.36-1.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}filesystem-2.3.0-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}basesystem-8.0-4.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}glibc-2.3.3-74.i386.rpm 2>/dev/null
        ${RPM_COMMAND}bzip2-libs-1.0.2-13.i386.rpm 2>/dev/null
        ${RPM_COMMAND}beecrypt-3.1.0-6.i386.rpm 2>/dev/null
        ${RPM_COMMAND}zlib-1.2.1.2-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}popt-1.9.1-21.i386.rpm 2>/dev/null
        ${RPM_COMMAND}elfutils-libelf-0.96-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}termcap-5.4-3.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}libtermcap-2.0.8-39.i386.rpm 2>/dev/null
        ${RPM_COMMAND}mktemp-1.5-10.i386.rpm 2>/dev/null
#        rm /bin/sh
        ${RPM_COMMAND}bash-3.0-17.i386.rpm 2>/dev/null
        ${RPM_COMMAND}libselinux-1.17.14-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}shadow-utils-4.0.3-37.i386.rpm 2>/dev/null
        ${RPM_COMMAND}rpm-libs-4.3.2-21.i386.rpm 2>/dev/null
        ${RPM_COMMAND}libstdc++-3.4.2-6.fc3.i386.rpm 2>/dev/null
        ${RPM_COMMAND}db4-4.2.52-6.i386.rpm 2>/dev/null
        ${RPM_COMMAND}rpm-4.3.2-21.i386.rpm 2>/dev/null
	;;
    4)
	# echo
	# echo Bootstrap full featured rpm with busybox-rpm from $method
	# echo hit ENTER; read x
	cat /root/scripts/${version}/rm_links_before_bootstrap_rpm.txt | while read f
	do
	    [ -h $f ] && rm $f
	done

	/bin/busybox grep -v '^-- ' /root/scripts/${version}/rpm_packages.disc1 | while read p; do
	    ${RPM_COMMAND}${p}
	done
	;;
    esac
	
    # RPM_COMMAND="/bin/rpm -ivh --nodeps --replacepkgs ${RPM_PATH}"
    # RPM_INFO="/bin/rpm -qi -p ${RPM_PATH}"
    set +x
    ;;
ftprpms)
set -x
    mkdir /ftptmp

    # set the ftpget-options
    useropt="-u `echo $LOGIN | cut -d: -f1`"
    passopt="-p `echo $LOGIN | cut -d: -f2 | cut -d@ -f1`"
    hostopt="$HOST$PORT"
    pathopt="$FILE_PATH"

    case $version in
    3)
	rpmlist=tzdata-2004b-2.noarch.rpm   \
	    glibc-common-2.3.3-74.i386.rpm  \
	    libgcc-3.4.2-6.fc3.i386.rpm     \
	    setup-2.5.36-1.noarch.rpm       \
	    filesystem-2.3.0-1.i386.rpm     \
	    basesystem-8.0-4.noarch.rpm     \
	    glibc-2.3.3-74.i386.rpm         \
	    bzip2-libs-1.0.2-13.i386.rpm    \
	    beecrypt-3.1.0-6.i386.rpm       \
	    zlib-1.2.1.2-1.i386.rpm         \
	    popt-1.9.1-21.i386.rpm          \
	    elfutils-libelf-0.96-1.i386.rpm \
	    termcap-5.4-3.noarch.rpm        \
	    libtermcap-2.0.8-39.i386.rpm    \
	    mktemp-1.5-10.i386.rpm          \
	    bash-3.0-17.i386.rpm            \
	    libselinux-1.17.14-1.i386.rpm   \
	    shadow-utils-4.0.3-37.i386.rpm  \
	    rpm-libs-4.3.2-21.i386.rpm      \
	    libstdc++-3.4.2-6.fc3.i386.rpm  \
	    db4-4.2.52-6.i386.rpm           \
	    rpm-4.3.2-21.i386.rpm
	;;
    4)
	cat /root/scripts/${version}/rm_links_before_bootstrap_rpm.txt | while read f
	do
	    [ -h $f ] && rm $f
	done

	rpmlist=`grep -v '^-- ' /root/scripts/${version}/rpm_packages.disc1`
	;;
    esac

    for rpm in $rpmlist
    do
	echo trying to get $rpm via ftp, hit ENTER
	read x
	/bin/busybox ftpget -v $useropt $passopt $hostopt /ftptmp/$rpm $pathopt/$rpm || {
	    echo ftpget failed for $pathopt/$rpm | tee -a $install_log
	    echo hit ENTER
	    read x
	    continue
	}
	echo trying to busybox/rpm -i $rpm, hit ENTER
	read x
	/bin/busybox rpm -i /ftptmp/$rpm
	rm /ftptmp/$rpm
    done
    rmdir /ftptmp

    # RPM_COMMAND="/bin/rpm -ivh --nodeps --replacepkgs FTP://${LOGIN}${HOST}${PORT}${FILE_PATH}"
    ;;
html)
    echo Cannot bootstrap rpm from html-source - exiting
    echo hit ENTER
    read x
    return
    ;;
esac

if [ "$version" = '4' ]; then
    # these two links are missing but needed
    cd lib
    ln -s libssl.so.0.9.7f libssl.so.5
    ln -s libcrypto.so.0.9.7f libcrypto.so.5
    cd -
fi

echo /bin/rpm should work now
echo "Enter 'rpm' on the second console and check if the new rpm is working"
echo hit ENTER; read x

/root/scripts/unmount_installsource.sh
