#! /bin/sh
#
#  do_partitioning.sh

if [ "$PART_DEV" = '' ]; then
    echo PART_DEV ist leer, ENTER; read x
fi

## Not used any more, we use fdisk from busybox
# If not defined in the config file, ask.
partition_tool=fdisk
if [ -z "$partition_tool" ]; then
    echo "You can choose 'fdisk' or 'cfdisk' to partition your drive(s)."
    echo "Hit ENTER to skip disk partitioning only if you already."
    echo "have the required partitions set up."
    echo
    echo -n "Please enter your choice [ fdisk / cfdisk ]: "
    partition_tool=
    read partition_tool
fi

case $partition_tool in
fdisk )
    ;;
cfdisk )
    ;;
* )
    echo "Skipping disk partitioning."
    partition_tool=
    sleep 1
    ;;
esac
echo partition_tool=$partition_tool >> $install_log

if [ -n "$partition_tool" ]; then
    dialog --defaultno --msgbox '
    You can partition your harddisk(s) now.

    Please create at least 2 partitions: root and swap.
    A regular LINUX partition (e.g. root) is of type "82 Linux".
    A swap partition is identified by its type "83 Linux swap".

    You may also create additional partitions for
    /boot, /home, /usr, etc.
' 14 70
    [ $? -eq 0 ] && answer=yes || answer=no
    if [ "$answer" = 'yes' ]; then

	# Call the program of choice on the selected device(s).
	# FIXME
	# Add the ability to auto partition here!

	for device in `echo "$PART_DEV"`
	do
	    echo
	    echo
	    echo "Running $partition_tool on <$device>."
	    echo
	    echo "This is how the current layout looks like"
	    echo "to use this layout press 'q' ENTER"
	    echo "if you need help to change this layout press 'm' ENTER"
	    echo
	    $partition_tool -l $device
	    $partition_tool $device
	done
    else
	echo "Harddisk(s) NOT partitioned, hit ENTER"; read x
    fi
fi

# echo
# echo
# echo "The following is your partition layout (Linux partitions only):"
# echo
# $partition_tool -l | grep Linux
# 
# echo hit ENTER; read x