#!/bin/sh

# Copyright (C) 2002 Michael Fratoni
# <Devon@tuxfan.homeip.net>
# Copyright (C) The "RULE" project
# http://www.freesoftware.fsf.org/rule

# Remove temporary directories, unmount file systems,
# and reboot the machine cleanly.

# Get rid of the /newroot/proc link, replace with a directory.
rm -f /newroot/proc
mkdir /newroot/proc

# Get rid of the temporary mount point.
rmdir /newroot/oldroot

# Clear out /etc/mtab, otherwise the kernel thinks / is mounted on reboot.
echo > /newroot/etc/mtab

echo -n "You're ready to reboot? [yes / NO] "
read answer
if [ -z "$answer" ]; then
    echo "I require an answer. 'yes' or 'no' will suffice."
    echo
    echo -n "You're ready to reboot? [yes / NO] "
    read answer
fi

if [ "$answer" != "yes" ] && [ "$answer" != "y" ]; then
    echo "Please complete the install and reboot manually."
    echo "Exiting."
    exit
fi

# Unmount all mounted  partitions.
echo "Unmounting filesystems."
umount -a
# Turn off swap.
echo "Turning off swap."
for device in $SWAP_DEV
  do
  swapoff $device
done;

echo "Done. The install is complete! - rebooting"
sleep 2
reboot
